<template>
<div class="relative">
    <button href="#" class="flex items-center" 
    @click="toggleVisibility" 
    @keydown.space.exact.prevent="toggleVisibility" 
    @keydown.esc.exact="hideDropdown" 
    @keydown.shift.tab="hideDropdown" @keydown.up.exact.prevent="startArrowKeys" @keydown.down.exact.prevent="startArrowKeys">  
    <!-- <img :src="`/flags/${locale}.png`" alt="flag" class="w-8 h-8"> -->
    <img src="/flags/language-icon.png" alt="language-switcher-flag" class="w-8 h-8">
      <span class="ml-2">{{ localeToName(locale) }}</span>
      <svg fill="currentColor" xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" width="24" height="24"><path class="heroicon-ui" d="M15.3 9.3a1 1 0 0 1 1.4 1.4l-4 4a1 1 0 0 1-1.4 0l-4-4a1 1 0 0 1 1.4-1.4l3.3 3.29 3.3-3.3z"></path></svg>
    </button>
    <transition name="dropdown-fade">
        <ul v-if="isVisible" ref="dropdown" class="absolute normal-case z-30 font-normal xs:left-0 lg:right-0 bg-white shadow overflow-hidden rounded w-48 border mt-2 py-1 lg:z-20">
            <li>
                <a :href="linkEn" ref="account" class="flex items-center px-3 py-3 hover:bg-gray-200" 
                @keydown.up.exact.prevent="" 
                @keydown.tab.exact="focusNext(false)" 
                @keydown.down.exact.prevent="focusNext(true)" 
                @keydown.esc.exact="hideDropdown">
                    <!-- <img src="/flags/en.png" alt="flag" class="w-8 h-8"> -->
       <span class="ml-2 language">English | الإنجليزية</span>
                    <!--span class="label label-default"><span class="flag-icon flag-icon-gb"></span> English</span-->  
                </a>
            </li>

            <!--
            <li>
                <a :href="linkRu" class="flex items-center px-3 py-3 hover:bg-gray-200" 
                @keydown.shift.tab="focusPrevious(false)" 
                @keydown.up.exact.prevent="focusPrevious(true)" 
                @keydown.down.exact.prevent="focusNext(true)"
                @keydown.tab.exact="hideDropdown" 
                @keydown.esc.exact="hideDropdown">
                    <img src="/flags/ru.png" alt="flag" class="w-8 h-8">
       <span class="ml-2">Russian</span>
                    <span class="label label-default"><span class="flag-icon flag-icon-ru"></span> Russian</span> 
                </a>
            </li>
            -->
            <li>
                <a :href="linkAr" class="flex items-center px-3 py-3 hover:bg-gray-200" 
                @keydown.shift.tab="focusPrevious(false)" 
                @keydown.up.exact.prevent="focusPrevious(true)" 
                @keydown.down.exact.prevent="" 
                @keydown.tab.exact="hideDropdown" 
                @keydown.esc.exact="hideDropdown">
                 <!--<img src="/flags/ar.png" alt="flag" class="w-8 h-8"> -->
                 <span class="ml-2 language">عربى | Arabic</span>
                    <!--span class="label label-default"><span class="flag-icon flag-icon-ae"></span> 
                    Arabic</span-->
                </a>
            </li>
        </ul>
    </transition>
</div>
</template>

<script>
export default {
    props: ['locale', 'link-en', 'link-ru','link-ar'],
    data() {
        return {
            isVisible: false,
            focusedIndex: 0,
        }
    },
    methods: {
        localeToName (locale) {
            if (locale.startsWith('en')) {
                return 'English | الإنجليزية';
            } else if (locale.startsWith('ar')) {
                return 'عربى | Arabic';
            }
            return locale
        },
        toggleVisibility() {
            this.isVisible = !this.isVisible
        },
        hideDropdown() {
            this.isVisible = false
            this.focusedIndex = 0
        },
        startArrowKeys() {
            if (this.isVisible) {
                // this.$refs.account.focus()
                this.$refs.dropdown.children[0].children[0].focus()
            }
        },
        focusPrevious(isArrowKey) {
            this.focusedIndex = this.focusedIndex - 1
            if (isArrowKey) {
                this.focusItem()
            }
        },
        focusNext(isArrowKey) {
            this.focusedIndex = this.focusedIndex + 1
            if (isArrowKey) {
                this.focusItem()
            }
        },
        focusItem() {
            this.$refs.dropdown.children[this.focusedIndex].children[0].focus()
        },
        setLocale(locale) {
            this.$i18n.locale = locale
            this.setLocale(locale);
            this.$router.push({
                params: {
                    language: locale
                }
            })
            this.hideDropdown()
        }
    }
}
</script>


<style scoped>
    button {
      padding: 0;
      border: none;
      font: inherit;
      color: inherit;
      background-color: transparent;
      cursor: pointer;
    }
    .flex {
        display: flex;
        align-items: center;
    }
    img {
        width: 1.5rem;
        height: 1.5rem;
    }
    ul {
        list-style-type: none;
        padding-left: 0;
        position: absolute;
        z-index: 30;
        right: 0;
    }
    .relative {
        position: relative;
        padding-top: 5%;
        padding-bottom: 5%;
    }
    .dropdown-fade-enter-active, .dropdown-fade-leave-active {
        transition: all .1s ease-in-out;
    }
    .dropdown-fade-enter, .dropdown-fade-leave-to {
        opacity: 0;
        transform: translateY(-12px);
    }
    .language {
        white-space: nowrap
    }
</style>
